#include <iostream>
#include <fstream>
#include <sstream>
#include <vector>
#include <string>
#include "../pvo-block.hh"
#include "../pvo-header.hh"
#include "../pvo-FITS.hh"
#include "../pvo-utils.hh"
using namespace Header;
using namespace Block;
using namespace FITS;

int main()
{
  const int patternSize = 7
  int pattern[patternSize] = {1,1,2,3,5,8,13};
  std::stringstream ss;

  // DO 1-BIT DATA.
  // has nchan = 8, samp_grp = 5, grp_blk = 1
  vector<bool> bindata1(40);
  int place=0;
  for(int i=0;i<patternSize;i++){
    bindata1[place++] = false;
    for(int j=0;j<pattern[i];j++) bindata1[place++] = true;
  }
  for(int i=0;i<bindata1.size();i++) std::cout << bindata1[i];
  std::cout << endl;
  std::string binstring1 = binaryToString(bindata1);
  std::cout << binstring1 <<endl;

  char *data = new char[Block::dataLength];
  for(int i=0;i<bindata1.size();i++) data[i] = binstring1[i];
  for(int i=bindata1.size();i<Block::dataLength;i++) data[i] = 0;
  ss.str("");
  ss << "cp data/dummy_header_s70_1bit.dat data/fakedata_s70_1bit.dat";
  std::cerr << "Executing command: " << ss.str() << endl;
  system(ss.str().c_str());
  ofstream fdata;
  fdata.open("data/fakedata_s70_1bit.dat",ios_base::binary | ios::app);
  fdata << data;
  fdata.close();

//   std::string fhead = "data/dummy_header_s70_1bit.dat";
//   ifstream headfile(fhead.c_str());
//   DataBlock block1(idSurvey(fhead));
//   block1.readHeader(headfile);
//   block1.saveData((char *)binstring1.c_str(),binstring1.size());
//   PSRFits fitsfile1;
//   fitsfile1.initialise(block1);
//   std::string name = fitsfile1.getFITSname();
//   fitsfile1.writeSubintRow(block1);
//   fitsfile1.closeFile();
//   headfile.close();
//   std::stringstream ss;
//   ss << "mv " << name << " data/fakedata_1bit.fits";
//   std::cerr << "Executing command: " << ss.str() << endl;
//   system(ss.str().c_str());

  //------------------------------------------------------------
  // DO 2-BIT DATA.
  vector<int> bindata2(40);
  place=0;
  for(int i=0;i<patternSize;i++){
    int valuectr=0;
    bindata2[place++] = 0;
    for(int j=0;j<pattern[i];j++) bindata2[place++] = (valuectr++)%3 + 1;
  }
  for(int i=0;i<bindata2.size();i++) std::cout << bindata2[i];
  std::cout << endl;
  vector<bool> bindata2b(80);
  for(int i=0;i<40;i++){
    bindata2b[i*2] = bindata2[i]/2;
    bindata2b[i*2+1] = bindata2[i]%2;
  }
  for(int i=0;i<bindata2b.size();i++) std::cout << bindata2b[i];
  std::cout << endl;
  std::string binstring2 = binaryToString(bindata2b);
  std::cout << binstring2 <<endl;

  for(int i=0;i<bindata2.size();i++) data[i] = binstring2[i];
  for(int i=bindata2.size();i<Block::dataLength;i++) data[i] = 0;
  ss.str("");
  ss << "cp data/dummy_header_s70_2bit.dat data/fakedata_s70_2bit.dat";
  std::cerr << "Executing command: " << ss.str() << endl;
  system(ss.str().c_str());
  fdata.open("data/fakedata_s70_2bit.dat",ios_base::binary | ios::app);
  fdata << data;
  fdata.close();

//   fhead = "data/dummy_header_s70_2bit.dat";
//   headfile.open(fhead.c_str());
//   DataBlock block2(idSurvey(fhead));
//   block2.readHeader(headfile);
//   block2.saveData((char *)binstring2.c_str(),binstring2.size());
//   PSRFits fitsfile2;
//   fitsfile2.initialise(block2);
//   name = fitsfile1.getFITSname();
//   fitsfile2.writeSubintRow(block2);
//   fitsfile2.closeFile();
//   headfile.close();
//   ss.str("");
//   ss << "mv " << name << " data/fakedata_2bit.fits";
//   system(ss.str().c_str());

  //------------------------------------------------------------
  // DO 4-BIT DATA.
  std::string bindata4(40,'0');
  std::string values4="123456789abcdef";
  vector<int> bindata4int(40);
  place=0;
  int intplace=0;
  for(int i=0;i<patternSize;i++){
    int valuectr=0;
    bindata4[place++] = '0';
    bindata4int[intplace++] = 0;
    for(int j=0;j<pattern[i];j++) bindata4[place++] = values4[(valuectr++)%15];
    valuectr=0;
    for(int j=0;j<pattern[i];j++) bindata4int[intplace++] = (valuectr++)%15 + 1;
  }
  std::cout << bindata4 << endl;
  vector<bool> bindata4b(160);
  for(int i=0;i<40;i++){
    
    bindata4b[i*4]   = bindata4int[i]/8;
    bindata4b[i*4+1] = bindata4int[i]/4;
    bindata4b[i*4+2] = bindata4int[i]/2;
    bindata4b[i*4+3] = bindata4int[i]%2;
  }
  for(int i=0;i<bindata4b.size();i++) std::cout << bindata4b[i];
  std::cout << endl;
  std::string binstring4 = binaryToString(bindata4b);
  std::cout << binstring4 <<endl;

  for(int i=0;i<bindata4.size();i++) data[i] = binstring4[i];
  for(int i=bindata4.size();i<Block::dataLength;i++) data[i] = 0;
  ss.str("");
  ss << "cp data/dummy_header_s70_4bit.dat data/fakedata_s70_4bit.dat";
  std::cerr << "Executing command: " << ss.str() << endl;
  system(ss.str().c_str());
  fdata.open("data/fakedata_s70_4bit.dat",ios_base::binary | ios::app);
  fdata << data;
  fdata.close();

//   fhead = "data/dummy_header_s70_4bit.dat";
//   headfile.open(fhead.c_str());
//   DataBlock block4(idSurvey(fhead));
//   block4.readHeader(headfile);
//   block4.saveData((char *)binstring4.c_str(),binstring4.size());
//   PSRFits fitsfile4;
//   fitsfile4.initialise(block4);
//   name = fitsfile1.getFITSname();
//   fitsfile4.writeSubintRow(block4);
//   fitsfile4.closeFile();
//   headfile.close();
//   ss.str("");
//   ss << "mv " << name << " data/fakedata_4bit.fits";
//   system(ss.str().c_str());

}
